<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Geeklog 1.3                                                               |
// +---------------------------------------------------------------------------+
// | checkposts.php                                                            |
// |                                                                           |
// | Check for defective posts in the YaBB message database.                   |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2004 by the following authors:                              |
// |                                                                           |
// | Authors: Dirk Haun - dirk@haun-online.de                                  |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+//
// $Id: checkposts.php,v 1.1.1.1 2004/05/23 15:42:09 dhaun Exp $

error_reporting( E_ERROR | E_WARNING | E_PARSE | E_COMPILE_ERROR );

header ('Content-Type: text/plain');

// try to disable the execution time limit, if possible ...
if (function_exists ('set_time_limit')) {
    @set_time_limit (0);
}

$defective = 0;

$fd = opendir ('Messages/');
while ((false !== ($file = @readdir ($fd)))) {
    if ($file <> '.' && $file <> '..' && $file <> 'CVS' &&
            preg_match ('/\.txt$/i', $file)) {
        clearstatcache();
        $thread = file ('Messages/' . $file);

        foreach ($thread as $msg) {
            list($subject, $displayname, $email, $date, $username, $icon, $null, $ip, $txt, $e1, $e2) = explode ('|', $msg);

            if (empty ($displayname) || empty ($email) || empty ($date) ||
                    empty ($username) || empty ($ip) || empty ($txt)) {
                echo 'One or more posts in ' . $file . " appear to be defective.\n";
                $defective++;
                break;
            }
        }
    }
}

if ($defective == 0) {
    echo "No defective posts found.\n";
}

?>
