<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Geeklog 1.3                                                               |
// +---------------------------------------------------------------------------+
// | importforum.php                                                           |
// |                                                                           |
// | Import YaBB boards and posts into the Geeklog forum                       |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2004 by the following authors:                              |
// |                                                                           |
// | Authors: Dirk Haun - dirk@haun-online.de                                  |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+//
// $Id: importforum.php,v 1.1.1.1 2004/05/23 15:42:09 dhaun Exp $

require_once ('/path/to/geeklog/public_html/lib-common.php');
require_once ($_CONF['path_html'] . 'forum/include/gf_format.php');

require_once ($_CONF['path_system'] . 'classes/timer.class.php');
$_PAGE_TIMER = new timerobject(); 
$_PAGE_TIMER->startTimer();

header ('Content-Type: text/plain');

// try to disable the execution time limit, if possible ...
if (function_exists ('set_time_limit')) {
    @set_time_limit (0);
}

$_TABLES['temp_lookup_thread'] = $_DB_table_prefix . 'yabbtmplookupthreads';
$_TABLES['temp_lookup_user']   = $_DB_table_prefix . 'yabbtmplookupusers';

function create_temp_tables ()
{
    global $_TABLES;

    DB_query ("CREATE TABLE {$_TABLES['temp_lookup_thread']} (
                    thread varchar(255) NOT NULL default '',
                    pid varchar(255) NOT NULL default '',
                    INDEX idx_pid (pid),
                    PRIMARY KEY (thread)
               ) TYPE=MyISAM;");
}

function lookupName ($username)
{
    global $_TABLES;

    static $users;

    if (empty ($users)) {
        $users = array ();
    }

    if (empty ($users[$username])) {
        $username = addslashes ($username);
        $result = DB_query ("SELECT uid, glname FROM {$_TABLES['temp_lookup_user']} WHERE yabbname = '$username'");
        $A = DB_fetchArray ($result);
        $users[$username] = $A;
    } else {
        $A = $users[$username];
    }

    return $A;
}

function lookupThread ($thread)
{
    global $_TABLES;

    static $threadids;

    if (empty ($threadids)) {
        $threadids = array ();
    }

    if (empty ($threadids[$thread])) {
        $id = DB_getItem ($_TABLES['temp_lookup_thread'], 'pid',
                          "thread = '$thread'");
        $threadids[$thread] = $id;
    } else {
        $id = $threadids[$thread];
    }

    return $id;
}

function strdate2time ($strdate)
{
    $dt = explode ('/', $strdate);
    $m = intval ($dt[0]);
    $d = intval ($dt[1]);
    $dt = explode (' ', $dt[2]);
    $y = 2000 + intval ($dt[0]);
    $dt = explode (' ', $strdate);
    $t = $dt[2];
    $t = explode (':', $t);

    return mktime (intval ($t[0]), intval ($t[1]), intval ($t[2]), $m, $d, $y);
}

function replace_smilies ($txt)
{
    // YaBB smilies -> Forum smilies
    $smilies = array (                       // YaBB name
                       '&nbsp;;D'  => ':mrgreen:', // grin
                       '&gt;:(' => ':x',        // angry
                       '&nbsp;8)'  => ' B)',       // cool
                       '&nbsp;???' => ':?',  // huh
                       '&nbsp;::)' => ':roll:',    // rolleyes
                       '&nbsp;:-[' => ':oops:',    // embarassed
                       '&nbsp;:-X' => ':|',        // lipsrsealed
                       '&nbsp;:-/' => ':|',        // undecided
                       '&nbsp;:-*' => ':D',        // kiss
                       "&nbsp;:'(" => ':cry:'      // cry
                     );

    foreach ($smilies as $yabb => $forum) {
        $txt = str_replace ($yabb, $forum, $txt);
    }

    return gf_replacesmilie ($txt);
}

function replace_bbcode ($txt)
{
    $txt = str_replace ('[b]',   '<b>',   $txt);
    $txt = str_replace ('[/b]',  '</b>',  $txt);
    $txt = str_replace ('[i]',   '<i>',   $txt);
    $txt = str_replace ('[/i]',  '</i>',  $txt);
    $txt = str_replace ('[tt]',  '<tt>',  $txt);
    $txt = str_replace ('[/tt]', '</tt>', $txt);

    $txt = str_replace ('[list]',  '<ul>',  $txt);
    $txt = str_replace ('[/list]', '</ul>', $txt);
    $txt = str_replace ('[*]',     '<li>',  $txt);

    $txt = preg_replace ('/\[color=([^\]]*)\]/', '<font color="\\1">', $txt);
    $txt = str_replace ('[/color]', '</font>', $txt);

    $txt = preg_replace ('/\[img\]([^\[]*)\[\/img\]/',
                         '<img src="\\1" alt="">', $txt);

    $txt = preg_replace ('/\[url=([^\]]*)\]([^\[]*)\[\/url\]/',
                         '<a href="\\1">\\2</a>', $txt);
    $txt = preg_replace ('/\[url\]([^\[]*)\[\/url\]/',
                         '<a href="\\1">\\1</a>', $txt);
    $txt = preg_replace ('/\[link=([^\]]*)\]([^\[]*)\[\/link\]/',
                         '<a href="\\1">\\2</a>', $txt);
    $txt = preg_replace ('/\[email\]([^\[]*)\[\/email\]/',
                         '<a href="mailto:\\1">\\1</a>', $txt);

    // these aren't supported ...
    $txt = preg_replace ('/\[glow=([^\]]*)\]/', '', $txt);
    $txt = str_replace ('[/glow]', '', $txt);
    $txt = preg_replace ('/\[shadow=([^\]]*)\]/', '', $txt);
    $txt = str_replace ('[/shadow]', '', $txt);

    // pre-format [quote] tags for the forum
    $txt = preg_replace ('/\[quote author=([^\] ]*)[^\]]*\]/',
                         '[quote BY=\\1] ', $txt);

    // YaBB uses <br> tags within [code] sections - replace them with linefeeds
    $offset = strpos ($txt, '[code]');
    if ($offset !== false) {
        do {
            $codeend = strpos ($txt, '[/code]', $offset + 6);
            if ($codeend === false) {
                break;
            }

            $code = substr ($txt, $offset + 6, ($codeend - $offset) - 6);
            $txt = substr ($txt, 0, $offset)
                 . '[code]' . str_replace ('<br>', "\n", $code) . '[/code]'
                 . substr ($txt, $codeend + 7);

            $offset = strpos ($txt, '[code]', $offset + 6);
        } while ($offset !== false);

        // now let the forum handle the [code] tags
        $txt = gf_handlecode ($txt);
    }

    return $txt;
}

function fix_forumlinks()
{
    global $_CONF, $_TABLES;

    $result = DB_query ("SELECT id,comment FROM {$_TABLES['gf_topic']} WHERE comment LIKE '%action=display;num=%'");
    $num = DB_numRows ($result);

    for ($i = 0; $i < $num; $i++) {
        $A = DB_fetchArray ($result);
        $txt = $A['comment'];

        while (preg_match ('/action=display;num=([0-9]*)/', $txt, $match) == 1) {
            $lookup = lookupThread ($match[1]);
            list ($forum, $pid) = explode (',', $lookup);
            $newlink = sprintf ($_CONF['site_url']
                    . '/forum/viewtopic.php?forum=%d&amp;showtopic=%d',
                    $forum, $pid);

            $txt = preg_replace ('/http:[^;:]*;action=display;num=([0-9]*)/', $newlink, $txt, 1);
        }
        $txt = preg_replace ('/;start=[0-9]*/', '', $txt);

        if ($txt != $A['comment']) {
            $txt = addslashes ($txt);
            DB_query ("UPDATE {$_TABLES['gf_topic']} SET comment = '$txt' WHERE id = {$A['id']}");
        }
    }
}

function set_sticky ()
{
    global $_TABLES;

    $stk = file ('Boards/sticky.stk');
    foreach ($stk as $sticky) {
        $sticky = trim ($sticky);

        $lookup = lookupThread ($sticky);
        list ($forum, $pid) = explode (',', $lookup);

        if (!empty ($pid)) {
            DB_query ("UPDATE {$_TABLES['gf_topic']} SET sticky = 1 WHERE id = '$pid'");
        }
    }
}

function import_threads ($board, $forumid)
{
    global $_CONF, $_TABLES;

    $threads = file ('Boards/' . $board . '.txt');
    $threads = array_reverse ($threads); // oldest posts first

    foreach ($threads as $t) {
        if (empty ($t)) {
            continue;
        }

        $tmp = explode ('|', $t);
        $tid = trim ($tmp[0]);
        if (empty ($tid)) {
            continue;
        }

        $locked = 0;
        if (trim ($tmp[8]) == '1') {
            $locked = 1;
        }

        $pid = 0;
        $first = true;

        $data = file ('Messages/' . $tid . '.data');
        $v = explode ('|', $data[0]);
        $views = $v[0];

        $thread = file ('Messages/' . $tid . '.txt');
        $replies = sizeof ($thread) - 1;

        $lastupdated = 0;
        foreach ($thread as $msg) {
            list($subject, $displayname, $email, $date, $username, $icon, $null, $ip, $txt, $e1, $e2) = explode ('|', $msg);

            if (empty ($displayname) || empty ($email) || empty ($date) ||
                    empty ($username) || empty ($ip) || empty ($txt)) {
                echo 'One or more posts in ' . $tid . ".txt appear to be defective. Aborting.\n";
                break;
            }

            if ($username == 'Guest') {
                $uid = 1;
            } else {
                list ($uid, $username) = lookupName ($username);
                if (empty ($uid)) {
                    $uid = 1;
                } else {
                    $displayname = $username;
                }
            }
            $time = strdate2time ($date);
            if ($time > $lastupdated) {
                $lastupdated = $time;
            }

            $displayname = addslashes ($displayname);
            $subject = addslashes (COM_undoSpecialChars ($subject));
            $txt = addslashes (replace_smilies (replace_bbcode ($txt)));
            $ip = addslashes ($ip);

            if ($uid > 1) {
                DB_query ("INSERT INTO {$_TABLES['gf_topic']} (forum, pid, uid, name, date, subject, comment, ip, replies, views, postmode, locked, mood) VALUES ($forumid, $pid, $uid, '$displayname', '$time', '$subject', '$txt', '$ip', $replies, $views, 'html', $locked, NULL)");
            } else {
                $email = addslashes ($email);
                DB_query ("INSERT INTO {$_TABLES['gf_topic']} (forum, pid, uid, name, date, email, subject, comment, ip, replies, views, postmode, locked, mood) VALUES ($forumid, $pid, $uid, '$displayname', '$time', '$email', '$subject', '$txt', '$ip', $replies, $views, 'html', $locked, NULL)");
            }

            if ($first) {
                $pid = DB_insertId ();
            }
            $first = false;
            $replies = 0;
            $views = 0;
            $locked = 0;
        }
        DB_query ("UPDATE {$_TABLES['gf_topic']} SET lastupdated = '$lastupdated' WHERE id = $pid");

        // store $tid -> $pid relation so that we can fix the forum links later
        $tmppid = $forumid . ',' . $pid;
        DB_query ("INSERT INTO {$_TABLES['temp_lookup_thread']} (thread, pid) VALUES ('$tid', '$tmppid')");
    }
}


// MAIN

create_temp_tables ();

$catstart = 10;
$catinc   = 10;
$boardstart = 10;
$boardinc   = 10;

$catcounter = $catstart;
$boardcounter = $boardstart;

$cat = file ('Variables/cat.txt');
foreach ($cat as $c) {

    $c = trim ($c);

    $main = file ('Boards/' . $c . '.cat');

    $catname = trim ($main[0]);
    echo $catname . ":\n";

    $catname = addslashes ($catname);
    DB_query ("INSERT INTO {$_TABLES['gf_categories']} (cat_name, cat_dscp, cat_order) VALUES ('$catname', '$catname', $catcounter)");
    $catcounter += $catinc;
    $boardcounter = $boardstart;

    $catid = DB_insertId ();

    for ($i = 2; $i < sizeof ($main); $i++) {
        $board = trim ($main[$i]);

        $info = file ('Boards/' . $board . '.dat');
        $boardname = trim ($info[0]);
        $description = trim ($info[1]);
        echo '  ' . $boardname . ' (' . $description . ")\n";

        $boardname = addslashes ($boardname);
        $description = addslashes ($description);
        DB_query ("INSERT INTO {$_TABLES['gf_forums']} (forum_name, forum_dscp, forum_order, forum_cat) VALUES ('$boardname', '$description', $boardcounter, $catid)");
        $boardcounter += $boardinc;

        $forumid = DB_insertId ();

        import_threads ($board, $forumid);
    }
}

fix_forumlinks ();

set_sticky ();

$exectime = $_PAGE_TIMER->stopTimer();
echo "\nTime: $exectime seconds.\n";

?>
