<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Geeklog 1.3                                                               |
// +---------------------------------------------------------------------------+
// | importusers.php                                                           |
// |                                                                           |
// | Import YaBB users into the Geeklog database.                              |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2004 by the following authors:                              |
// |                                                                           |
// | Authors: Dirk Haun - dirk@haun-online.de                                  |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+//
// $Id: importusers.php,v 1.1.1.1 2004/05/23 15:42:09 dhaun Exp $

require_once ('/path/to/geeklog/public_html/lib-common.php');

require_once ($_CONF['path_system'] . 'classes/timer.class.php');
$_PAGE_TIMER = new timerobject(); 
$_PAGE_TIMER->startTimer();

header ('Content-Type: text/plain');

// try to disable the execution time limit, if possible ...
if (function_exists ('set_time_limit')) {
    @set_time_limit (0);
}

$_TABLES['temp_lookup_user']   = $_DB_table_prefix . 'yabbtmplookupusers';


function create_temp_tables ()
{
    global $_TABLES;

    DB_query ("CREATE TABLE {$_TABLES['temp_lookup_user']} (
                    yabbname varchar(255) NOT NULL default '',
                    glname varchar(16) NOT NULL default '',
                    uid mediumint(8) NOT NULL default '1',
                    INDEX lookup_uid(uid),
                    PRIMARY KEY (yabbname)
               ) TYPE=MyISAM;");
}

function add_lookup_entry ($yabbname, $glname, $uid)
{
    global $_TABLES;

    $yabbname = addslashes ($yabbname);
    $glname = addslashes (substr ($glname, 0, 16));
    DB_query ("INSERT INTO {$_TABLES['temp_lookup_user']} (yabbname, glname, uid) VALUES ('$yabbname', '$glname', $uid)");
}

// create a new user - pretty much copied from Geeklog's users.php
function create_user ($username, $data)
{
    global $_CONF, $_TABLES;

    static $firstuser = true;

    $username = addslashes ($username);
    $fullname = addslashes ($data['fullname']);
    $email = addslashes ($data['email']);
    $homepage = addslashes ($data['url']);
    $regdate = addslashes ($data['regdate']);
    $passwd = md5 ($data['pwd']);

    DB_query ("INSERT INTO {$_TABLES['users']} (username, fullname, passwd, email, homepage, regdate, cookietimeout) VALUES ('$username', '$fullname', '$passwd', '$email', '$homepage', '$regdate', '{$_CONF['default_perm_cookie_timeout']}')");

    $uid = DB_insertId ();

    if ($firstuser) {
        // remember uid of the first user account we've created
        DB_query ("INSERT INTO {$_TABLES['vars']} (name, value) VALUES ('yabb_first_user', $uid)");
        $firstuser = false;
    }

    // add user to 'Logged-In Users' and 'All Users' groups
    $normal_grp = DB_getItem ($_TABLES['groups'], 'grp_id',
                              "grp_name = 'Logged-in Users'");
    $all_grp = DB_getItem ($_TABLES['groups'], 'grp_id',
                           "grp_name = 'All Users'");

    DB_query ("INSERT INTO {$_TABLES['group_assignments']} (ug_main_grp_id,ug_uid) values ($normal_grp, $uid)");
    DB_query ("INSERT INTO {$_TABLES['group_assignments']} (ug_main_grp_id,ug_uid) values ($all_grp, $uid)");

    DB_query ("INSERT INTO {$_TABLES['userprefs']} (uid) VALUES ($uid)");
    DB_query ("INSERT INTO {$_TABLES['userinfo']} (uid) VALUES ($uid)");

    DB_query ("INSERT INTO {$_TABLES['usercomment']} (uid, commentmode, commentlimit) VALUES ($uid, '{$_CONF['comment_mode']}', '{$_CONF['comment_limit']}')");

    if ($_CONF['emailstoriesperdefault'] == 1) {
        DB_query ("INSERT INTO {$_TABLES['userindex']} (uid) VALUES ($uid)");
    } else {
        DB_query ("INSERT INTO {$_TABLES['userindex']} (uid, etids) VALUES ($uid, '-')");
    }

    return $uid;
}


// MAIN

// numerical suffix for when identical usernames exist in both YaBB and
// Geeklog, but they belong to different people,
// e.g. 'joe' -> 'joe2004'
$uname_suffix = 2004;

create_temp_tables ();

    $user = array ();

    $fd = opendir ('Members/');
    while ((false !== ($file = @readdir ($fd)))) {
        if ($file <> '.' && $file <> '..' && $file <> 'CVS' &&
                preg_match ('/\.dat$/i', $file)) {
            clearstatcache();
            $info = file ('Members/' . $file);

            $n = explode ('.', $file);
            $username = $n[0];
            $pwd = trim ($info[0]);
            $fullname = trim ($info[1]);
            $email = trim ($info[2]);
            $url = trim ($info[4]);
            $regdate = trim ($info[14]);
            $dt = explode ('/', $regdate);
            $m = intval ($dt[0]);
            $d = intval ($dt[1]);
            $dt = explode (' ', $dt[2]);
            $y = intval ($dt[0]);
            $dt = explode (' ', $regdate);
            $t = $dt[2];
            $regdate = sprintf ("%4d-%02d-%02d %s", $y + 2000, $m, $d, $t);

            $u['fullname'] = $fullname;
            $u['email'] = $email;
            $u['pwd'] = $pwd;
            $u['regdate'] = $regdate;
            $u['url'] = $url;

            $user[$username] = $u;
        }
    }

    echo 'Found ' . sizeof ($user) . " YaBB forum users.\n";

    $newusers = 0;
    $existing = 0;
    $newusername = 0;
    $twousernames = 0;
    $longnames = 0;

    foreach ($user as $username => $data) {

        $result = DB_query ("SELECT uid,username,email FROM {$_TABLES['users']} WHERE (username LIKE '$username') OR (email = '{$data['email']}')");
        $A = DB_fetchArray ($result);

        if (empty ($A['uid'])) {
            // user exists in YaBB but not in Geeklog (yet)
            $newusers++;
            $uid = create_user ($username, $data);
            add_lookup_entry ($username, $username, $uid);
            if (strlen ($username) > 16) {
                $longnames++;
            }
        } else if ($A['email'] != $data['email']) {
            // identical username but different email address
            $cnt = $uname_suffix;
            do { // find new unique username
                $newname = sprintf ($username . '%d', $cnt);
                if (strlen ($newname) > 16) {
                    $newname = substr ($newname, 0, 12) + substr ($newname, -4);
                }
                $cnt++;
            } while (DB_count ($_TABLES['users'], 'username', $newname) != 0);
            $newusers++;
            $newusername++;
            $uid = create_user ($newname, $data);
            add_lookup_entry ($username, $newname, $uid);
        } else if ($A['username'] != $username) {
            // identical email address, but different username
            $existing++;
            $twousernames++;
            add_lookup_entry ($username, $A['username'], $A['uid']);
        } else {
            // this user already exists in YaBB and Geeklog
            $existing++;
            add_lookup_entry ($A['username'], $A['username'], $A['uid']);
        }
    }

    echo $newusers . ' new users have been created, ' . $existing
         . " already existed\n";
    echo $newusername . " users were assigned a new username\n";
    echo $twousernames . " users had different usernames for YaBB and Geeklog\n";
    echo $longnames . " users had usernames longer than 16 characters.\n";

$exectime = $_PAGE_TIMER->stopTimer();
echo "\nTime: $exectime seconds.\n";

?>
