<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Geeklog 1.3                                                               |
// +---------------------------------------------------------------------------+
// | notifyusers.php                                                           |
// |                                                                           |
// | Notify users about username changes.                                      |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2004 by the following authors:                              |
// |                                                                           |
// | Authors: Dirk Haun - dirk@haun-online.de                                  |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+//
// $Id: notifyusers.php,v 1.1.1.1 2004/05/23 15:42:09 dhaun Exp $

require_once ('/path/to/geeklog/public_html/lib-common.php');

header ('Content-type: text/plain');

// try to disable the execution time limit, if possible ...
if (function_exists ('set_time_limit')) {
    @set_time_limit (0);
}

$_TABLES['temp_lookup_user']   = $_DB_table_prefix . 'yabbtmplookupusers';

function send_email ($uid, $oldname, $msg)
{
    global $_CONF, $_TABLES;

    $result = DB_query ("SELECT username,email FROM {$_TABLES['users']} WHERE uid = $uid");
    $A = DB_fetchArray ($result);

    $mailbody = '';
    foreach ($msg as $m) {
        $m = str_replace ('%newname%', $A['username'], $m);
        $m = str_replace ('%oldname%', $oldname, $m);
        $m = str_replace ('%sitename%', $_CONF['site_name'], $m);
        $m = str_replace ('%siteurl%', $_CONF['site_url'], $m);

        $mailbody .= $m;
    }

    $subject = $_CONF['site_name'] . ' Forum Information';

    COM_mail ($A['email'], $subject, $mailbody);
}

// the email for those who were assigned a new username
$newusername = file ('newusername.txt');

// the email for those who had two accounts
$twousernames = file ('twousernames.txt');

// the email for those who had usernames with more than 16 characters
$longusername = file ('longusername.txt');

$firstyabbuser = DB_getItem ($_TABLES['vars'], 'value',
                             "name = 'yabb_first_user'");

$result = DB_query ("SELECT uid,yabbname FROM {$_TABLES['temp_lookup_user']} WHERE (yabbname <> glname)");
$num = DB_numRows ($result);

for ($i = 0; $i < $num; $i++) {

    $A = DB_fetchArray ($result);
    if (strlen ($A['yabbname']) > 16) {
        // this user had a YaBB username with more than 16 characters
        send_email ($A['uid'], $A['yabbname'], $longusername);
    } else if ($A['uid'] >= $firstyabbuser) {
        // this user was assigned a new username
        send_email ($A['uid'], $A['yabbname'], $newusername);
    } else {
        // this user had different usernames for YaBB and Geeklog
        send_email ($A['uid'], $A['yabbname'], $twousernames);
    }
}

?>
